Bug 827927 - Doxygen causes slightly different images on i686 and x86_64
Doxygen causes slightly different images on i686 and x86_64
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: graphviz (Show other bugs)
17
Unspecified Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Jaroslav Škarvada
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-03 16:37 EDT by Robert Scheck
Modified: 2013-08-01 13:16 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-01 13:16:43 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
popt-devel-1.13-10.fc17.x86_64.rpm (333.08 KB, application/x-rpm)
2012-06-03 16:37 EDT, Robert Scheck
no flags Details
popt-devel-1.13-10.fc17.i686.rpm (333.09 KB, application/x-rpm)
2012-06-03 16:38 EDT, Robert Scheck
no flags Details
Remove -ffast-math (507 bytes, patch)
2012-06-13 09:23 EDT, Jan Kratochvil
no flags Details | Diff
Reproducer for problem 2 (723 bytes, text/plain)
2012-07-25 05:06 EDT, Jaroslav Škarvada
no flags Details
Reproducer for problem 3 (1.68 KB, text/plain)
2012-07-25 08:47 EDT, Jaroslav Škarvada
no flags Details

  None (edit)
Description Robert Scheck 2012-06-03 16:37:06 EDT
Description of problem:
The x86_64 -devel package has files which conflict with those in the i686
package.

Version-Release number of selected component (if applicable):
graphviz-2.28.0-16.fc17

How reproducible:
Everytime, attempt to install both packages on an x86_64 system.
  
Actual results:
Doxygen causes slightly different images on i686 and x86_64.

Expected results:
Doxygen should cause same images on i686 and x86_64.

Additional info:
File conflict for /usr/share/doc/popt-devel-1.13/html/findme_8c__incl.png in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/findme_8h__dep__incl.png in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/poptint_8h.html in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/poptint_8h__dep__incl.map in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/poptint_8h__dep__incl.png in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/poptparse_8c__incl.png in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/structpoptContext__s__coll__graph.png in popt-devel-1.13-10.fc17
File conflict for /usr/share/doc/popt-devel-1.13/html/system_8h__incl.png in popt-devel-1.13-10.fc17
Comment 1 Robert Scheck 2012-06-03 16:37:52 EDT
Created attachment 588919 [details]
popt-devel-1.13-10.fc17.x86_64.rpm
Comment 2 Robert Scheck 2012-06-03 16:38:29 EDT
Created attachment 588920 [details]
popt-devel-1.13-10.fc17.i686.rpm
Comment 3 Jan Kratochvil 2012-06-13 08:16:34 EDT
The changes are like:
-<area shape="rect" id="node3" href="$popt_8c.html" title="popt.c" alt="" coords="4,80,61,107"/>
+<area shape="rect" id="node3" href="$popt_8c.html" title="popt.c" alt="" coords="5,80,63,107"/>
Comment 4 Jan Kratochvil 2012-06-13 09:23:26 EDT
Created attachment 591498 [details]
Remove -ffast-math

This is fix for the *.html difference problem - remove -ffast-math.

Verified the problem happens with kept -ffast-math and the problem disappears after removing -ffast-math.

Unfortunately there still remains a problem with different PNGs:
file /usr/share/doc/popt-devel-1.13/html/nav_g.png conflicts between attempted installs of popt-devel-1.13-10.fc18.i686 and popt-devel-1.13-10.fc18.x86_64
file /usr/share/doc/popt-devel-1.13/html/structpoptContext__s__coll__graph.png conflicts between attempted installs of popt-devel-1.13-10.fc18.i686 and popt-devel-1.13-10.fc18.x86_64

Neither libpng nor netpbm uses -ffast-math, not sure why that can happen (and what is the real producer of these .png files).
Comment 5 Jaroslav Škarvada 2012-07-25 05:06:03 EDT
Created attachment 600245 [details]
Reproducer for problem 2

Currently it seems there are (at least) 3 different problems:

1) The --ffast-math is ugly and needs to be removed. It will fix some wrong files (e.g. some PNG files in popt-devel).

2) On i686 if compiled with -O2, the compiler optimizes the code to do more arithmetic in FPU registers (which are wider than C float/double types), so there are less load/store that normally truncate the wider floats. As the error accumulates in FPU registers it finally causes several trunc/round errors. We can enforce the gcc to issue explicit load/store on problematic parts of code, but the beahviour of gcc optimizer could change with new versions and such hacks could became non-effective. Reproducer for this problem is attached (dot.dot). Other, probably more safe solutions for this problem are -O0 or --ffloat-store. The latter seems to have less performance penalty (because there are only some more load/store). I created very simple benchmark (root.dot from graphviz gallery, T500 computer, 32 bit, avg and stddev for 10 runs, stddev are written in braces, less numbers are better):
-O2                   -ffloat-store         -O0
4.305 (0.018) s       4.354 (0.040) s       4.696 (0.045) s

Also SSE instructions on 64 bit are faster in all cases, but that's another story (same test, same machine, 64 bit):
-O2
3.732 (0.021) s

3) It seems there is problem with pango rendering on F17. Currently I am not sure whether it is problem in pango itself or problem in pango support code in graphviz (will investigate). It is reproducible on structpoptContext__s__coll__graph.png from popt (I will attach the dot source for it later). It seems the source image differs in one pixel, i.e. the bmp check:

$ dot.32 structpoptContext__s__coll__graph.dot -Tbmp -o popt32.bmp
$ md5sum pop32.bmp
2170763b639e52e0201563ee21a37ce2  popt32.bmp
$ dot.64 structpoptContext__s__coll__graph.dot -Tbmp -o popt64.bmp
$ md5sum pop64.bmp
66075ccef3859434473f8367c8075ca6  popt64.bmp
$ diff -u <(hexdump ./popt32.bmp) <(hexdump ./popt64.bmp)
--- /dev/fd/63	2012-07-25 10:47:11.063453467 +0200
+++ /dev/fd/62	2012-07-25 10:47:11.063453467 +0200
@@ -3810,7 +3810,7 @@
 003b0c0 f5fd fffa ffff ffff ffff ffff ffff ffff
 003b0d0 ffff ffff ffff ffff ffff ffff ffff ffff
 *
-003b260 feff fefd 52d5 dcaa b86f ddf7 ffee ffff
+003b260 feff fefd 53d5 dcaa b86f ddf7 ffee ffff
 003b270 ffff ffff ffff ffff ffff ffff beef cddf
 003b280 9a32 4dd4 faa7 f4e9 ffff ffff ffff ffff
 003b290 ffff ffff ffff ffff ffff ffff ffff ffff

Also same with PNG:
$ dot.32 structpoptContext__s__coll__graph.dot -Tpng -o popt32.png
$ md5sum popt32.png 
57f0d432d6674373b5b26c60cde61fba  popt32.png
$ dot.64 structpoptContext__s__coll__graph.dot -Tpng -o popt64.png
$ md5sum popt64.png 
5040532e0beddbc1db99c2bbe0267a94  popt64.png

But it seems to be OK with gd:
$ dot.32 structpoptContext__s__coll__graph.dot -Tpng:gd:gd -o popt32.png
252880812119d25df696c6fa8395638e  popt32.png
$ dot.64 structpoptContext__s__coll__graph.dot -Tpng:gd:gd -o popt64.png
252880812119d25df696c6fa8395638e  popt64.png

This third problem is also not reproducible on RHEL-6, which prompts me that it may be pango problem.
Comment 6 Jaroslav Škarvada 2012-07-25 08:47:37 EDT
Created attachment 600292 [details]
Reproducer for problem 3

The 3) seems to be an regression in graphviz (pango plugin). It is not reproducible with graphviz-2.26.0.
Comment 7 Jaroslav Škarvada 2012-08-17 11:07:56 EDT
Fixes for 1) and 2) committed into rawhide/f18.
Comment 8 Fedora End Of Life 2013-07-04 01:57:42 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 9 Fedora End Of Life 2013-08-01 13:16:47 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.